<?php
//Frontpage//
// $Id: frontpage.php,v 1.15 2003/10/04 22:10:32 saka_car Exp $
/**
* Content code
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.15 $
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package MOS
* @version $Revision: 1.15 $
*/

require_once( $mainframe->getPath( 'front_html' ) );

if (isset( $HTTP_COOKIE_VARS["sessioncookie"] )) {
	$gid = checkaccess( $HTTP_COOKIE_VARS["sessioncookie"], $database );
} else {
	$gid = 0;
}

// option masks
define( "MASK_BACKTOLIST", 0x0001 );
define( "MASK_READON",     0x0002 );
define( "MASK_POPUP",      0x0004 );
define( "MASK_IMAGES",     0x0020 );

define( "MASK_HIDEAUTHOR",     0x0100 );
define( "MASK_HIDECREATEDATE", 0x0200 );
define( "MASK_HIDEMODIFYDATE", 0x0400 );

//$id = mosGetParam( $_REQUEST, 'id', 0 );

frontpage( $database, $gid, $Itemid );

/**
* Select all the content items that are within the 'frontpage' date display times
*
* The following parameters are available to the frontpage
* count=n : display a maximum of n lines
* intro=m : only show the intro for the first m items
* image=b : b=true shows images otherwise just text
* @param database A database connection object
*/
function frontpage( &$database, $gid, $Itemid ) {
	global $mainframe;

	$access = !$mainframe->getCfg( 'shownoauth' );

	$menu= new mosMenu( $database );
	$menu->load( $Itemid );
	$params = mosParseParams( $menu->params );

	$count = isset( $params->count ) ? $params->count : 6;
	$intro = isset( $params->intro ) ? $params->intro : 3;
	$image = @$params->image ? MASK_IMAGES : 0;
	$header = @$params->header;
	$empty = @$params->empty;

	if ($header) {
		echo $header;
	}

	$t = new mosTemplate( $database );
	$t->load( 0 );

	$database->setQuery( "SELECT a.*, u.name AS author, u.usertype"
		. "\nFROM #__content AS a"
		. "\nLEFT JOIN #__users AS u ON u.id = a.created_by"
		. "\nLEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
		. "\nWHERE a.state='1' AND a.mask&1=1"
		. ($access ? "\n	AND a.access <= $gid" : "")
		. "\n	AND (publish_up = '0000-00-00 00:00:00' OR publish_up <= NOW())"
		. "\n	AND (publish_down = '0000-00-00 00:00:00' OR publish_down >= NOW())"
		. "\nORDER BY f.ordering, a.ordering ASC, a.catid, a.sectionid"
		. ($count ? " LIMIT $count" : "")
	);
	echo $database->getErrorMsg();
	$rows = $database->loadObjectList();

	$n = count( $rows );
	if ($count && $count < $n) {
		$n = $count;
	}


	if ($n > 0) {
		$col=$t->col_main;

		echo "\n<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";

		$i2=0;
		$n2=$n;
		$intro2 = $intro;
		// Leading story
		if ($col==3) {
			echo "<tr>\n";
			echo "<td valign=\"top\" colspan=\"2\">\n";
			show( $database, $rows[$i2], MASK_READON|$image, $gid );
			echo "</td>\n";
			echo "</tr>\n";
			$i2++;
			$n2--;
			$intro2--;
		}

		for ($i=0; $i < $n2; $i++) {
			if (!($i%2) || $col==1) {
				echo "<tr>\n";
			}

			echo $col!=1 ? "<td valign=\"top\">\n" : "<td width=\"50%\" valign=\"top\">\n";
			if ($i < $intro2 || $intro==0) {
				show( $database, $rows[$i+$i2], MASK_READON|$image, $gid );
			} else {
				HTML_frontpage::showLinks( $rows, $intro, $n );
				echo "</td>\n</tr>\n";
				break;
			}
			echo "</td>\n";

			if ($i%2 || $col==1) {
				echo "</tr>\n";
			}
		}
		echo "\n</table>";

	} else {
		if ($empty) {
			echo "<br /><br />$empty";
		} else {
			echo "<br /><br />No items to display";
		}
	}
}

function show( &$database, $row, $mask=0, $gid ) {
	global $mosConfig_hideAuthor, $mosConfig_hideCreateDate, $mosConfig_hideModifyDate;

	if ($row->id === null || $row->state != 1) {
		echo _NOT_AUTH;
		return;
	}

	$mask |= $mosConfig_hideAuthor ? MASK_HIDEAUTHOR : 0;
	$mask |= $mosConfig_hideCreateDate ? MASK_HIDECREATEDATE : 0;
	$mask |= $mosConfig_hideModifyDate ? MASK_HIDEMODIFYDATE : 0;

	// do the images
	if ($mask&MASK_IMAGES) {
		$row->images = explode( "\n", $row->images );
		$images = array();

		foreach ($row->images as $img) {
			$temp = explode( '|', trim( $img ) );
			if(is_array($temp) && count($temp) > 0)
			{
				if(!isset($temp[1]))
					$temp[1] = "";

				if(!isset($temp[2]))
					$temp[2] = "";

				if(!isset($temp[3]))
					$temp[3] = 0;

				$images[] = "<img src=\"./images/stories/$temp[0]\" align=\"$temp[1]\" hspace=\"6\" alt=\"$temp[2]\" border=\"$temp[3]\" />";
			}
		}

		$text = explode( '{mosimage}', $row->introtext );

		$row->text = $text[0];

		for ($i=0, $n=count( $text )-1; $i < $n; $i++) {
			if(isset($images[$i]) && isset($text[$i+1]))
			$row->text .= $images[$i].$text[$i+1];
		}
	} else {
		$row->text = str_replace( '{mosimage}', '', $row->introtext );
	}

	// record the hit
	if (!($mask&MASK_READON)) {
		$row->hit();
	}

	HTML_frontpage::show( $row, $mask, $gid );
}
?>
